Index: /trunk/classes/c/c_audio/cwaudio.c
===================================================================
--- /trunk/classes/c/c_audio/cwaudio.c	(revision 92)
+++ /trunk/classes/c/c_audio/cwaudio.c	(revision 93)
@@ -257,7 +257,7 @@
       cwMoveNotebookButtonsWarp4(hwnd, IDPB_ID3HELP, 15);
 
-      if(!getMessage(name, IDSTR_TRACKNAME, sizeof(name),  queryResModuleHandle(), hwnd))
-        strcpy(name, "Track name");
-      WinSetWindowText(WinWindowFromID(hwnd,IDGB_ID3TAGS), name);
+      /*if(!getMessage(name, IDSTR_TRACKNAME, sizeof(name),  queryResModuleHandle(), hwnd))
+        strcpy(name, "Track name");*/
+      WinSetWindowText(WinWindowFromID(hwnd,IDGB_ID3TAGS), "");
 
       WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3NAME),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)MAX_EA_SIZE-1),0);
@@ -267,11 +267,9 @@
       WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3YEAR),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)MAX_EA_SIZE-1),0);
       WinSendMsg(WinWindowFromID(hwnd,IDDD_ID3GENRE),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)MAX_EA_SIZE-1),0);
-#if 0
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3NAME),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Name)-1),0);
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3ARTIST),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Artist)-1),0);
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3ALBUM),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Album)-1),0);
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3COMMENT),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Comment)-1),0);
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3YEAR),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Year)-1),0);
-#endif      
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3NAME),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)30),0);
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3ARTIST),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)30),0);
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3ALBUM),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)30),0);
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3COMMENT),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)30),0);
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3YEAR),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)4),0);
       /* Fill drop downlist with knwon genres */
       hwndTemp=WinWindowFromID(hwnd, IDDD_ID3GENRE);
@@ -443,5 +441,5 @@
   //We have a major tab so we need a name
   if(!getMessage(pageName, ID_TRACKNAMEPAGENAME, sizeof(pageName), queryResModuleHandle(), hwndNotebook))
-    strcpy(pageName, "~Track name");
+    strcpy(pageName, "~Track meta data");
   pageinfo.pszName = pageName;
   //Insert the page into the settings notebook
Index: /trunk/classes/help/en/cwmm.ipf
===================================================================
--- /trunk/classes/help/en/cwmm.ipf	(revision 92)
+++ /trunk/classes/help/en/cwmm.ipf	(revision 93)
@@ -14,8 +14,6 @@
 Get the IO procedure from
 :p.
-:link reftype=launch
-object='netscape.exe'
-data='http://www.math.berkeley.edu/~roconnor/'.
-http&colon.//www.math.berkeley.edu/~roconnor/:elink.
+
+https&colon.//hobbes.nmsu.edu/download/pub/os2/apps/mmedia/codec/MMeCS-MP3_1-2.zip
 
 :h1 res=011.ID3 Tag
@@ -91,5 +89,5 @@
 :eul.
 
-:h1 res=012.Track names
+:h1 res=012.Track meta data
 :p.
 Use this page for the editing of track information. The contents of the fields will be saved
@@ -165,3 +163,2 @@
 
 :euserdoc.
-
Index: /trunk/classes/idl/idl_audio/cwaudio.c
===================================================================
--- /trunk/classes/idl/idl_audio/cwaudio.c	(revision 92)
+++ /trunk/classes/idl/idl_audio/cwaudio.c	(revision 93)
@@ -251,7 +251,7 @@
       cwMoveNotebookButtonsWarp4(hwnd, IDPB_ID3HELP, 15);
 
-      if(!getMessage(name, IDSTR_TRACKNAME, sizeof(name),  queryResModuleHandle(), hwnd))
-        strcpy(name, "Track name");
-      WinSetWindowText(WinWindowFromID(hwnd,IDGB_ID3TAGS), name);
+      /*if(!getMessage(name, IDSTR_TRACKNAME, sizeof(name),  queryResModuleHandle(), hwnd))
+        strcpy(name, "Track name");*/
+      WinSetWindowText(WinWindowFromID(hwnd,IDGB_ID3TAGS), "");
 
       WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3NAME),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)MAX_EA_SIZE-1),0);
@@ -261,10 +261,10 @@
       WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3YEAR),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)MAX_EA_SIZE-1),0);
       WinSendMsg(WinWindowFromID(hwnd,IDDD_ID3GENRE),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)MAX_EA_SIZE-1),0);
-#if 0
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3NAME),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Name)-1),0);
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3ARTIST),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Artist)-1),0);
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3ALBUM),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Album)-1),0);
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3COMMENT),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Comment)-1),0);
-      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3YEAR),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)sizeof(_id3Year)-1),0);
+#if 1
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3NAME),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)30),0);
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3ARTIST),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)30),0);
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3ALBUM),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)30),0);
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3COMMENT),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)30),0);
+      WinSendMsg(WinWindowFromID(hwnd,IDEF_ID3YEAR),EM_SETTEXTLIMIT,MPFROMSHORT((SHORT)4)-1),0);
 #endif      
       /* Fill drop downlist with knwon genres */
@@ -399,5 +399,5 @@
   //We have a major tab so we need a name
   if(!getMessage(pageName, ID_TRACKNAMEPAGENAME, sizeof(pageName), queryResModuleHandle(), hwndNotebook))
-    strcpy(pageName, "~Track name");
+    strcpy(pageName, "~Track meta data");
   pageinfo.pszName = pageName;
   //Insert the page into the settings notebook
Index: /trunk/classes/res/de/cwaudio_de.rc
===================================================================
--- /trunk/classes/res/de/cwaudio_de.rc	(revision 92)
+++ /trunk/classes/res/de/cwaudio_de.rc	(revision 93)
@@ -71,5 +71,5 @@
 ID_WAVEINFOPAGENAME "~Audio-Information"
 ID_ID3TAGSPAGENAME  "~ID3-Tags"
-ID_TRACKNAMEPAGENAME "~Trackname"
+ID_TRACKNAMEPAGENAME "~Track meta data"
 IDSTR_TRACKNAME      "Trackname"
 
Index: /trunk/classes/res/en/cwaudio_en.dlg
===================================================================
--- /trunk/classes/res/en/cwaudio_en.dlg	(revision 92)
+++ /trunk/classes/res/en/cwaudio_en.dlg	(revision 93)
@@ -11,5 +11,5 @@
         PUSHBUTTON      "~Cancel", IDPB_CANCEL, 87, 1, 40, 14
         PUSHBUTTON      "~Help", IDPB_ID3HELP, 130, 1, 40, 14, BS_HELP
-        GROUPBOX        "ID3 Tags", IDGB_ID3TAGS, 6, 17, 202, 97
+        GROUPBOX        "", IDGB_ID3TAGS, 6, 17, 202, 97
         LTEXT           "Name:", 210, 9, 95, 57, 8
         ENTRYFIELD      "", IDEF_ID3NAME, 73, 95, 127, 8, ES_MARGIN
@@ -33,5 +33,5 @@
             WS_VISIBLE | NOT WS_SAVEBITS
     BEGIN
-        GROUPBOX        "Audio info", IDGB_WAVEINFO, 6, 4, 154, 67, NOT 
+        GROUPBOX        "", IDGB_WAVEINFO, 6, 4, 154, 67, NOT 
                         WS_GROUP
         LTEXT           "Samplerate:", IDST_SAMPLERATELABEL, 17, 35, 76, 8
@@ -51,5 +51,5 @@
             WS_VISIBLE
     BEGIN
-        GROUPBOX        "Image Information", IDGB_IMAGEINFO, 6, 4, 154, 78, 
+        GROUPBOX        "", IDGB_IMAGEINFO, 6, 4, 154, 78, 
                         NOT WS_GROUP
         LTEXT           "Width:", IDST_IMAGEWIDTHLABEL, 17, 35, 76, 8
Index: /trunk/classes/res/en/cwaudio_en.rc
===================================================================
--- /trunk/classes/res/en/cwaudio_en.rc	(revision 92)
+++ /trunk/classes/res/en/cwaudio_en.rc	(revision 93)
@@ -71,7 +71,7 @@
 STRINGTABLE 
 BEGIN
-ID_WAVEINFOPAGENAME "~Audio information"
+ID_WAVEINFOPAGENAME "~Audio details"
 ID_ID3TAGSPAGENAME  "~ID3 Tags"
-ID_TRACKNAMEPAGENAME "~Track name"
+ID_TRACKNAMEPAGENAME "~Track meta data"
 IDSTR_TRACKNAME      "Trackname"
 