Index: trunk/bootcode/airboot.asm
===================================================================
--- trunk/bootcode/airboot.asm	(revision 95)
+++ trunk/bootcode/airboot.asm	(revision 96)
@@ -1313,13 +1313,4 @@
                 call    AFTERCRAP_Main
 
-                ; [Linux support removed since v1.02]
-                ; Now get FAT16-Linux Kernel Partition, If requested
-                ;cmp     [CFG_LinuxKrnlPartition], 0FFh
-                ;je      MBR_Main_NoLinuxKrnlPartition
-                ;call    LINUX_InitFAT16access
-    ;MBR_Main_NoLinuxKrnlPartition:
-
-
-
     MBR_Main_ReEnterBootMenuPre:
                 ; SetUp PartitionPointers for BootMenu (filter non-bootable)
@@ -1576,8 +1567,4 @@
 include special/virus.asm       ; Virus Detection / Anti-Virus
 size_virus = $-b_virus
-
-; [Linux support removed since v1.02]
-;include special/fat16.asm       ; FAT-16 Support
-;include special/linux.asm       ; Linux Kernel Support
 
 b_billsuxx:
@@ -1899,10 +1886,4 @@
 ; It is truncated to 11 chars because AiR-BOOT currently does not support
 ; longer labelnames. The name is also capitalized.
-;OS2_InstallVolume       db  12 dup (0)
-;OS2_InstallVolume       db  'HIGHLOG' ,0
-;OS2_InstallVolume       db  'ECS-MIDDLE',0,0
-;OS2_InstallVolume       db  'ECS-HIGH',0,0,0,0
-;OS2_InstallVolume       db  'ECS-HIGH',0,'NO',0
-;OS2_InstallVolume       db  'KANWEG2',0
 OS2_InstallVolume       db  0,'NOPHASEONE' ,0
 
@@ -2317,18 +2298,4 @@
 LVM_CRCTable        dd   256 dup (?) ; LVM-CRC (->SPECiAL\LVM.asm)
 
-;~ ; [Linux support removed since v1.02]
-;~ FAT16_Drive             db     ?    ; FAT-16: Drive of FAT16-partition
-;~ FAT16_AbsPartitionBegin dd     ?    ; FAT-16: LBA Begin of Partition
-;~ FAT16_SecsPerCluster    db     ?    ; FAT-16: Sectors Per Cluster
-;~ FAT16_NumOfRootEntries  dw     ?    ; FAT-16: Number of Root Entries
-;~ FAT16_SecsPerFAT        dw     ?    ; FAT-16: Sectors Per FAT
-;~ FAT16_AbsFATBegin       dd     ?    ; FAT-16: LBA Begin of FAT
-;~ FAT16_AbsRootBegin      dd     ?    ; FAT-16: LBA Begin of Root
-;~ FAT16_AbsClusterBegin   dd     ?    ; FAT-16: LBA Begin of Clusters
-;~ FAT16_FATCacheSector    db     ?    ; FAT-16: FAT-Sector No in Cache
-;~ FAT16_FATCache          db   512 dup (?) ; FAT-16: FAT-Area Cache
-;~ LINUX_KernelEntries     db   680 dup (?) ; 34*20 -> Space for Kernel-Entries
-;~ LINUX_KernelNo          db     ?         ; Total of Kernels in KernelEntries
-;~ LINUX_KernelSizeTable   db   120 dup (?) ; Size-Table (6 bytes per kernel)
 
 
Index: trunk/bootcode/regular/bootmenu.asm
===================================================================
--- trunk/bootcode/regular/bootmenu.asm	(revision 95)
+++ trunk/bootcode/regular/bootmenu.asm	(revision 96)
@@ -955,20 +955,4 @@
         mov     Menu_EntryAutomatic, dl
 
-        ;~ ; [Linux support removed since v1.02]
-        ;~ ; Okay, now we check if Default/Last Kernel Partition Name is available...
-        ;~ ;  if so, simply set Menu_EntryDefault/Menu_EntryLast.
-        ;~ mov     si, offset CFG_LinuxDefaultKernel
-        ;~ call    LINUX_SearchKernelName        ; DL - Filtered Entry No
-        ;~ cmp     dl, 0FFh
-        ;~ je      BMRMV_DefaultKernelNF
-        ;~ mov     Menu_EntryDefault, dl
-    ;~ BMRMV_DefaultKernelNF:
-        ;~ mov     si, offset CFG_LinuxLastKernel
-        ;~ call    LINUX_SearchKernelName        ; DL - Filtered Entry No
-        ;~ cmp     dl, 0FFh
-        ;~ je      BMRMV_LastKernelNF
-        ;~ mov     Menu_EntryLast, dl
-    ;~ BMRMV_LastKernelNF:
-
         ; restlichen Variablen berechnen...
         mov     dl, Menu_TotalParts
Index: trunk/bootcode/regular/partmain.asm
===================================================================
--- trunk/bootcode/regular/partmain.asm	(revision 95)
+++ trunk/bootcode/regular/partmain.asm	(revision 96)
@@ -36,17 +36,4 @@
     call    PART_FixUpSelectionNumber
     mov     CFG_PartAutomatic, dl
-
-; [Linux support removed since v1.02]
-;   ; Fix-Up Linux Kernel Partition - If lost, search for FAT-16
-;   mov     bl, 06h
-;   mov     dl, CFG_LinuxKrnlPartition
-;   call    PART_FixUpPartitionNumber
-;   mov     CFG_LinuxKrnlPartition, dl
-;
-;   ; Fix-Up Linux Root Partition - If lost, search for Linux partition (83h)
-;   mov     bl, 83h
-;   mov     dl, CFG_LinuxRootPartition
-;   call    PART_FixUpPartitionNumber
-;   mov     CFG_LinuxRootPartition, dl
    ret
 PART_FixUpDefaultPartitionValues EndP
@@ -264,18 +251,4 @@
     PCMPP_NoResumeBootSeqInclude:
 
-; [Linux support removed since v1.02]
-;   ; Now include all Linux Kernels, if any available...
-;   movzx   cx, LINUX_KernelNo
-;   or      cx, cx
-;   jz      PCMPP_NoLinuxKernels
-;   mov     ax, offset LINUX_KernelEntries
-;  PCMPP_KernelLoop:
-;      mov     ds:[bx], ax
-;      add     bx, 2
-;      add     ax, LocIPT_LenOfIPT
-;   dec     cx
-;   jnz     PCMPP_KernelLoop
-;  PCMPP_NoLinuxKernels:
-
         ;movzx   cx, CFG_Partitions ; LocIPT_MaxPartitions
         mov   cl,CFG_Partitions ; LocIPT_MaxPartitions
@@ -378,8 +351,4 @@
         je      PCTS_IsFloppy                       ; Is Floppy
 
-; [Linux support removed since v1.02]
-;   cmp     ax, offset LINUX_KernelEntries
-;   jae     PCTS_IsKernelEntry
-
         ;
         ; Is partition, AX contains pointer to IPT entry
@@ -390,9 +359,4 @@
         mov     dl, al                          ; Index in IPT
         ret
-
-; [Linux support removed since v1.02]
-;  PCTS_IsKernelEntry:
-;   mov     dl, 0FDh
-;   ret
 
     PCTS_IsBIOSbootSeq:
@@ -469,15 +433,6 @@
 ; Destroyed: AX
 PART_GetSizeElementPointer      Proc Near   Uses bx
-; [Linux support removed since v1.02]
-;   cmp     ax, offset LINUX_KernelEntries
-;   jae     PGSEP_IsKernelEntry
         mov     si, offset PartitionSizeTable
         sub     ax, offset PartitionTable
-;   jmp     PGSEP_Continue
-; [Linux support removed since v1.02]
-;  PGSEP_IsKernelEntry:
-;   mov     si, offset LINUX_KernelSizeTable
-;   sub     ax, offset LINUX_KernelEntries
-;  PGSEP_Continue:
         mov     bl, LocIPT_LenOfIPT
         div     bl                            ; Divide with IPTlength
@@ -1053,9 +1008,4 @@
         call    MBR_Teletype
 
-
-; [Linux support removed since v1.02]
-;      cmp     dh, 0FDh
-;      je      PSP_IsKernel
-
         ;~ pusha
         ;~ call    MBR_Teletype
@@ -1077,16 +1027,4 @@
         call    MBR_TeletypeVolName
         jmp     PSP_IsFloppyCDROMetc                                                ; JUMPS BUITEN SI POP !!! AANPASSEN
-
-
-; [Linux support removed since v1.02]
-;    PSP_IsKernel:
-;      IFDEF ReleaseCode
-;         ; Save configuration on HDD boots (save CFG_LinuxLastKernel)
-;         call    DriveIO_SaveConfiguration
-;      ENDIF
-;      call    MBR_Teletype       ; Prints out BootingNow2 including KernelName
-;      mov     si, offset TXT_BootingNowKernel
-;      call    MBR_Teletype
-;      jmp     PSP_IsFloppyCDROMetc
 
 
@@ -1417,8 +1355,4 @@
         je      PSP_ResumeBIOSbootSeq
 
-; [Linux support removed since v1.02]
-;   cmp     al, 0FDh                        ; Kernel-Booting ?
-;   je      PSP_KernelBooting
-
         jmp     PSP_StartNormal
 
@@ -1428,12 +1362,4 @@
         dw      0FFF0h
         dw      0F000h
-
-; [Linux support removed since v1.02]
-;  PSP_KernelBooting:
-;   call    LINUX_LoadKernel              ; DS:SI - Entry Pointer to Kernel
-;   db      0EAh                          ; if return to here -> Reboot
-;   dw      0FFF0h
-;   dw      0F000h
-
 
 
Index: trunk/bootcode/regular/partscan.asm
===================================================================
--- trunk/bootcode/regular/partscan.asm	(revision 95)
+++ trunk/bootcode/regular/partscan.asm	(revision 96)
@@ -80,21 +80,4 @@
         mov     cx, LocIPT_MaxPartitions
         rep     movsb
-
-; [Linux support removed since v1.02]
-;   ; Search for any Linux partition and remember, if it got found...
-;   mov     si, offset PartitionTable
-;   movzx   cx, CFG_Partitions
-;   xor     dl, dl                        ; DL - Is Linux here ?
-;   or      cx, cx
-;   jz      PSSFP_NoPartitions
-;  PSSFP_LinuxLoop:
-;      cmp     bptr [si+LocIPT_SystemID], 083h  ; Hard-Coded
-;      jne     PSSFP_NoLinux
-;      mov     dl, 1                      ; Linux found...
-;     PSSFP_NoLinux:
-;      add     si, LocIPT_LenOfIPT
-;   loop    PSSFP_LinuxLoop
-;  PSSFP_NoPartitions:
-;   mov     GotLinux, dl                  ; Set Flag
 
         ; ...and finally check, if we need to set a Drive-Letter
Index: trunk/bootcode/setup/main.asm
===================================================================
--- trunk/bootcode/setup/main.asm	(revision 95)
+++ trunk/bootcode/setup/main.asm	(revision 96)
@@ -773,17 +773,4 @@
 SETUP_EnterMenu_ExtendedOptions EndP
 
-; [Linux support removed since v1.02]
-;SETUP_EnterMenu_LinuxCommandLine Proc Near  Uses dx bp
-;   test    GotLinux, 1
-;   jz      SEMLCL_NoLinux
-;   call    SETUP_EnterMenu_EnterLinuxCmdLine
-;   ret
-;  SEMLCL_NoLinux:
-;   mov     cx, 0C04h
-;   mov     si, offset TXT_SETUP_NoLinuxInstalled
-;   call    SETUP_ShowErrorBox
-;   ret
-;SETUP_EnterMenu_LinuxCommandLine EndP
-
 SETUP_EnterMenu_DefineMasterPassword Proc Near
    mov     di, offset CFG_MasterPassword
@@ -799,65 +786,4 @@
 
 ; ============================================================================
-
-; [Linux support removed since v1.02]
-;SETUP_EnterMenu_EnterLinuxCmdLine Proc Near
-;   mov     cx, 0D05h
-;   call    VideoIO_Color
-;   mov     bx, 0C02h
-;   mov     dx, 0F4Fh
-;   call    VideoIO_MakeWindow
-;   mov     cx, 0F05h
-;   call    VideoIO_Color
-;
-;   mov     si, offset TXT_SETUP_EnterLinuxCmdLine
-;   call    GetLenOfString                ; CX - Len of Error Message
-;   mov     dx, cx
-;   mov     cx, 0D28h
-;   call    VideoIO_LocateToCenter        ; LocateToCenter 13, 40 using LenOfStr
-;   call    VideoIO_Print                 ; Writes 'Please enter Linux-CmdLine'
-;
-;   mov     cx, 0E05h
-;   call    VideoIO_Color
-;   mov     cx, 0E04h
-;   call    VideoIO_Locate
-;   mov     al, ' '
-;   mov     cl, 74
-;   call    VideoIO_PrintSingleMultiChar
-;   mov     cx, 0E04h
-;   call    VideoIO_Locate
-;   mov     si, offset CFG_LinuxCommandLine
-;   push    si
-;      call    VideoIO_Print              ; Writes Linux Command-Line
-;   pop     si
-;   mov     cx, 0E04h
-;   call    VideoIO_Locate
-;
-;   push    cs
-;   pop     es                            ; ES == CS
-;   mov     di, offset TmpSector
-;   mov     cx, 37
-;   rep     movsw                         ; Copy LinuxCmdLine -> TmpSectorSpace
-;
-;   mov     si, offset TmpSector
-;   mov     cx, 74
-;   call    VideoIO_LetUserEditString     ; -> does actual editing
-;   jnc     SEMELCL_UserAbort             ; Did user abort ?
-;
-;   ; Otherwise copy TmpSectorSpace to LinuxCmdLine
-;   mov     di, offset CFG_LinuxCommandLine
-;   mov     cx, 74
-;   call    GetLenOfName                  ; Get real length of Cmd-Line into CX
-;   jz      SEMELCL_NulLine
-;   rep     movsb
-;  SEMELCL_NulLine:
-;   mov     ax, 75
-;   sub     ax, cx
-;   mov     cx, ax
-;   xor     al, al
-;   rep     stosb                         ; Fill up with NULs
-;
-;  SEMELCL_UserAbort:
-;   ret
-;SETUP_EnterMenu_EnterLinuxCmdLine EndP
 
 ;        In: di - Place for Password to be defined
@@ -1466,141 +1392,4 @@
 SETUPMAGIC_ChangeDefaultSelection EndP
 
-; [Linux support removed since v1.02]
-;SETUPMAGIC_ChangeLinuxKernelPart Proc Near   Uses ax cx dx si es di
-;   mov     di, si
-;   mov     dl, ds:[bx]                   ; Cur Partition No.
-;   push    bx
-;      jc      SMCLKP_DoNotModify
-;     SMCLKP_NowGoOn:
-;      mov     dh, CFG_Partitions         ; CFG_Partitions is Base==1
-;      inc     dl                         ; +1 -> 00h instead FFh -> Disabled
-;     SMCLKP_RejectPartition:
-;      call    SETUPMAGIC_InternalCheckUp ; CheckUp DL (max. CFG_Partitions)
-;     SMCLKP_DoNotModify:
-;      or      dl, dl
-;      jz      SMCLKP_FunctionDisabled
-;      ; Get Partition-Pointer (SI) to Partition-To-Boot (DL)
-;      dec     dl
-;      call    PART_GetPartitionPointer
-;      inc     dl
-;      cmp     bptr ds:[si+LocIPT_SystemID], 06h ; FAT-16 required
-;      jne     SMCLKP_RejectPartition
-;   pop     bx
-;   add     si, LocIPT_Name               ; Location of Name
-;   push    cs
-;   pop     es
-;   add     di, LocMENU_ItemPack          ; DI points to ItemPack
-;   mov     cx, 11
-;   rep     movsb                         ; Copy cur PartitionName to ItemPack
-;   xor     al, al
-;   stosb                                 ; Ending Zero
-;  SMCLKP_WriteNewValue:
-;   dec     dl
-;   mov     ds:[bx], dl                   ; Set new partition number
-;   ret
-;
-;     SMCLKP_FunctionDisabled:
-;   pop     bx
-;   mov     si, offset TXT_SETUP_MAGIC_Disabled
-;   push    cs
-;   pop     es
-;   add     di, LocMENU_ItemPack          ; DI points to ItemPack...
-;   call    SETUPMAGIC_InternalCopyTillNUL
-;   jmp     SMCLKP_WriteNewValue
-;SETUPMAGIC_ChangeLinuxKernelPart EndP
-
-; [Linux support removed since v1.02]
-;SETUPMAGIC_ChangeLinuxRootPart  Proc Near   Uses ax cx dx si es di
-;   mov     di, si
-;   pushf                                 ; lame, but it's not working other ways
-;      test    ds:[GotLinux], 1
-;      jnz     SMCLRP_GotLinux
-;   popf
-;   add     di, LocMENU_ItemPack          ; DI points to ItemPack
-;   mov     si, offset TXT_SETUP_MAGIC_NoLinux
-;   push    cs
-;   pop     es
-;   call    SETUPMAGIC_InternalCopyTillNUL
-;   ret
-;     SMCLRP_GotLinux:
-;      mov     dl, ds:[bx]                ; Cur Partition No.
-;      mov     dh, CFG_Partitions
-;      dec     dh
-;   popf
-;   push    bx
-;      jc      SMCLRP_DoNotModify         ; Thou shall not modify :)
-;     SMCLRP_RejectPartition:
-;      call    SETUPMAGIC_InternalCheckUp ; CheckUp DL (max. CFG_Partitions-1)
-;     SMCLRP_DoNotModify:
-;      ; Get Partition-Pointer (SI) to Partition-To-Boot (DL)
-;      call    PART_GetPartitionPointer
-;      cmp     bptr ds:[si+LocIPT_SystemID], 083h
-;      jne     SMCLRP_RejectPartition
-;   pop     bx
-;   mov     ds:[bx], dl
-;   push    cs
-;   pop     es
-;   add     di, LocMENU_ItemPack          ; DI points to ItemPack...
-;   push    di
-;      mov     cx, 12
-;      xor     al, al
-;      rep     stosb                      ; Fill with NULs
-;   pop     di
-;   call    LINUX_TranslateToDEV          ; now translate thingie (DL)
-;   ret
-;SETUPMAGIC_ChangeLinuxRootPart  EndP
-
-; [Linux support removed since v1.02]
-; CH-ItemNo, CL-Add/Sub, BX-PtrToVariable, SI-ItemPack
-;SETUPMAGIC_ChangeLinuxDefaultKernel Proc Near   Uses ax cx dx si es di
-;   mov     di, si
-;   jc      SMCLDK_DoNotEdit
-;
-;   ; --- Edit Linux Default Kernel Name ---
-;   mov     cl, 29                        ; Left side: 29
-;   test    ch, 1000b
-;   jz      SMCLDK_NoRightSide
-;   and     ch, 111b
-;   mov     cl, 68                        ; Right side: 68
-;  SMCLDK_NoRightSide:
-;   add     ch, 6                         ; Koordinate umberechnen
-;   push    cx
-;      call    VideoIO_Locate
-;      mov     cx, 0E01h
-;      call    VideoIO_Color              ; Yellow on Blue
-;      mov     cl, 12
-;      mov     si, offset CFG_LinuxDefaultKernel
-;      call    VideoIO_FixedPrint         ; Print out [SI] (Length = CL)
-;   pop     cx
-;   call    VideoIO_Locate
-;   mov     cl, 11
-;   mov     si, offset CFG_LinuxDefaultKernel
-;   call    VideoIO_LetUserEditString
-;
-;   ; Final-Process string (which means upper-case it)
-;   mov     cl, 11
-;  SMCLDK_FinalProcessLoop:
-;      mov     al, bptr ds:[si]
-;      cmp     al, 'a'
-;      jb      SMCLDK_FinalProcessSkip
-;      cmp     al, 'z'
-;      ja      SMCLDK_FinalProcessSkip
-;      sub     al, 20h
-;     SMCLDK_FinalProcessSkip:
-;      mov     bptr ds:[si], al
-;      inc     si
-;   dec     cl
-;   jnz     SMCLDK_FinalProcessLoop
-;   ; --- End of Edit Linux Default Kernel Name ---
-;
-;  SMCLDK_DoNotEdit:
-;   push    cs
-;   pop     es
-;   add     di, LocMENU_ItemPack          ; DI points to ItemPack...
-;   mov     si, offset CFG_LinuxDefaultKernel
-;   mov     cx, 6                         ; Copy from CFG-Space to ItemPack
-;   rep     movsw
-;   ret
-;SETUPMAGIC_ChangeLinuxDefaultKernel EndP
 
 SETUPMAGIC_ChangeTimedKeyHandling Proc Near   Uses ax cx dx ds si es di