Index: /smplayer/trunk/debian-rvm/README
===================================================================
--- /smplayer/trunk/debian-rvm/README	(revision 97)
+++ /smplayer/trunk/debian-rvm/README	(revision 97)
@@ -0,0 +1,6 @@
+The Debian Package smplayer
+----------------------------
+
+Comments regarding the Package
+
+ -- ricardo <rvm@escomposlinux.org>  Fri, 25 May 2007 01:48:41 +0200
Index: /smplayer/trunk/debian-rvm/README.Debian
===================================================================
--- /smplayer/trunk/debian-rvm/README.Debian	(revision 97)
+++ /smplayer/trunk/debian-rvm/README.Debian	(revision 97)
@@ -0,0 +1,6 @@
+smplayer for Debian
+-------------------
+
+<possible notes regarding this package - if none, delete this file>
+
+ -- ricardo <rvm@escomposlinux.org>  Fri, 25 May 2007 01:48:41 +0200
Index: /smplayer/trunk/debian-rvm/changelog-orig
===================================================================
--- /smplayer/trunk/debian-rvm/changelog-orig	(revision 97)
+++ /smplayer/trunk/debian-rvm/changelog-orig	(revision 97)
@@ -0,0 +1,113 @@
+smplayer (0.6.9) hardy; urgency=low
+
+  * New release
+
+ -- Ricardo Villalba <rvm@escomposlinux.org>  Mon, 22 Feb 2010 11:59:41 +0100
+
+smplayer (0.6.8) hardy; urgency=low
+
+  * New release
+
+ -- Ricardo Villalba <rvm@escomposlinux.org>  Mon, 20 Jul 2009 12:32:59 +0200
+
+smplayer (0.6.7) hardy; urgency=low
+
+  * New release
+
+ -- Ricardo Villalba <rvm@escomposlinux.org>  Tue, 10 Mar 2009 00:35:35 +0100
+
+smplayer (0.6.6) hardy; urgency=low
+
+  * New release
+
+ -- Ricardo Villalba <rvm@escomposlinux.org>  Wed, 31 Dec 2008 13:56:36 +0100
+
+smplayer (0.6.5.1) hardy; urgency=low
+
+  * New release
+
+ -- Ricardo Villalba <rvm@escomposlinux.org>  Thu, 13 Nov 2008 02:11:24 +0100
+
+smplayer (0.6.5) hardy; urgency=low
+
+  * New release
+
+ -- Ricardo Villalba <rvm@escomposlinux.org>  Wed, 12 Nov 2008 02:35:29 +0100
+
+smplayer (0.6.4) hardy; urgency=low
+
+  * New release
+
+ -- Ricardo Villalba <rvm@escomposlinux.org>  Fri, 24 Oct 2008 17:45:16 +0200
+
+smplayer (0.6.3) hardy; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Thu, 25 Sep 2008 00:11:17 +0200
+
+smplayer (0.6.2) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Wed, 13 Aug 2008 23:49:11 +0200
+
+smplayer (0.6.1) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Wed, 28 May 2008 02:05:23 +0200
+
+smplayer (0.6.0final) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Tue, 13 May 2008 01:07:20 +0200
+
+smplayer (0.6.0rc4) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Tue, 15 Apr 2008 01:17:56 +0200
+
+smplayer (0.6.0rc3) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Sat, 22 Mar 2008 13:16:15 +0100
+
+smplayer (0.6.0rc2) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Wed, 13 Feb 2008 01:17:06 +0100
+
+smplayer (0.6.0rc1) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Thu, 31 Jan 2008 00:54:26 +0100
+
+smplayer (0.5.62) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Sat, 17 Nov 2007 00:35:49 +0100
+
+smplayer (0.5.61) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Wed, 10 Oct 2007 01:10:40 +0200
+
+smplayer (0.5.60) feisty; urgency=low
+
+  * New release
+
+ -- ricardo <rvm@escomposlinux.org>  Wed, 19 Sep 2007 22:29:06 +0200
+
+smplayer (0.5.59) unstable; urgency=low
+
+  * Initial Release.
+
+ -- Ricardo Villalba <rvm@escomposlinux.org>  Wed, 08 Aug 2007 01:02:48 +0200
Index: /smplayer/trunk/debian-rvm/compat
===================================================================
--- /smplayer/trunk/debian-rvm/compat	(revision 97)
+++ /smplayer/trunk/debian-rvm/compat	(revision 97)
@@ -0,0 +1,1 @@
+5
Index: /smplayer/trunk/debian-rvm/control
===================================================================
--- /smplayer/trunk/debian-rvm/control	(revision 97)
+++ /smplayer/trunk/debian-rvm/control	(revision 97)
@@ -0,0 +1,21 @@
+Source: smplayer
+Section: graphics
+Priority: extra
+Maintainer: Ricardo Villalba <rvm@escomposlinux.org>
+Build-Depends: debhelper (>= 5), libqt4-dev, zlib1g-dev
+Standards-Version: 3.7.2
+
+Package: smplayer
+Architecture: any
+Pre-Depends: dpkg (>= 1.14.12ubuntu3)
+Depends: ${shlibs:Depends}, mplayer | mplayer-nogui | mplayer-mt
+Recommends: smplayer-themes, alsa-utils, x11-utils
+Replaces: smplayer-translations
+Provides: smplayer-translations
+Description: A great front-end for MPlayer
+ SMPlayer intends to be a complete front-end for MPlayer, from basic features
+ like playing videos, DVDs, and VCDs to more advanced features like support
+ for MPlayer filters and more. One of the main features is the ability to
+ remember the state of a played file, so when you play it later it will resume
+ at the same point and with the same settings. smplayer is developed with
+ the Qt toolkit, so it's multi-platform.
Index: /smplayer/trunk/debian-rvm/copyright
===================================================================
--- /smplayer/trunk/debian-rvm/copyright	(revision 97)
+++ /smplayer/trunk/debian-rvm/copyright	(revision 97)
@@ -0,0 +1,26 @@
+This is smplayer, written and maintained by ricardo <rvm@escomposlinux.org>
+on Fri, 25 May 2007 01:48:41 +0200.
+
+The original source can always be found at:
+	ftp://ftp.debian.org/dists/unstable/main/source/
+
+Copyright Holder:  ricardo
+
+License:
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this package; if not, write to the Free Software
+  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+
+On Debian systems, the complete text of the GNU General
+Public License can be found in `/usr/share/common-licenses/GPL'.
Index: /smplayer/trunk/debian-rvm/docs
===================================================================
--- /smplayer/trunk/debian-rvm/docs	(revision 97)
+++ /smplayer/trunk/debian-rvm/docs	(revision 97)
@@ -0,0 +1,11 @@
+Audio_equalizer.txt
+Configuring_the_toolbars.txt
+Copying.txt
+dvdmenus.txt
+Finding_subtitles.txt
+Install.txt
+Not_so_obvious_things.txt
+Portable_Edition.txt
+Readme.txt
+Release_notes.txt
+Watching_TV.txt
Index: /smplayer/trunk/debian-rvm/menu
===================================================================
--- /smplayer/trunk/debian-rvm/menu	(revision 97)
+++ /smplayer/trunk/debian-rvm/menu	(revision 97)
@@ -0,0 +1,2 @@
+?package(smplayer):needs="X11" section="Apps/Graphics"\
+  title="smplayer" command="/usr/bin/smplayer"
Index: /smplayer/trunk/debian-rvm/rules
===================================================================
--- /smplayer/trunk/debian-rvm/rules	(revision 97)
+++ /smplayer/trunk/debian-rvm/rules	(revision 97)
@@ -0,0 +1,100 @@
+#!/usr/bin/make -f
+# -*- makefile -*-
+# Sample debian/rules that uses debhelper.
+# This file was originally written by Joey Hess and Craig Small.
+# As a special exception, when this file is copied by dh-make into a
+# dh-make output file, you may use that output file without restriction.
+# This special exception was added by Craig Small in version 0.37 of dh-make.
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+
+
+
+
+CFLAGS = -Wall -g
+
+ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
+	CFLAGS += -O0
+else
+	CFLAGS += -O2
+endif
+
+configure: configure-stamp
+configure-stamp:
+	dh_testdir
+	# Add here commands to configure the package.
+
+	touch configure-stamp
+
+
+build: build-stamp
+
+build-stamp: configure-stamp 
+	dh_testdir
+
+	# Add here commands to compile the package.
+	$(MAKE) PREFIX=/usr QMAKE=qmake-qt4 LRELEASE=lrelease-qt4 \
+            DOC_PATH="\\\"/usr/share/doc/smplayer\\\"" \
+            QMAKE_OPTS=DEFINES+=NO_DEBUG_ON_CONSOLE
+
+	touch $@
+
+clean:
+	dh_testdir
+	dh_testroot
+	rm -f build-stamp configure-stamp
+
+	# Add here commands to clean up after the build process.
+	-$(MAKE) clean
+
+	dh_clean 
+
+install: build
+	dh_testdir
+	dh_testroot
+	dh_clean -k 
+	dh_installdirs
+
+	# Add here commands to install the package into debian/smplayer.
+	$(MAKE) PREFIX=/usr DOC_PATH=/usr/share/doc/smplayer \
+            DESTDIR=$(CURDIR)/debian/smplayer install
+
+
+# Build architecture-independent files here.
+binary-indep: build install
+# We have nothing to do by default.
+
+# Build architecture-dependent files here.
+binary-arch: build install
+	dh_testdir
+	dh_testroot
+	dh_installchangelogs Changelog
+	dh_installdocs
+	dh_installexamples
+#	dh_install
+	dh_installmenu
+#	dh_installdebconf	
+#	dh_installlogrotate
+#	dh_installemacsen
+#	dh_installpam
+#	dh_installmime
+#	dh_python
+#	dh_installinit
+#	dh_installcron
+#	dh_installinfo
+	dh_installman
+	dh_link
+	dh_strip
+	dh_compress
+	dh_fixperms
+#	dh_perl
+#	dh_makeshlibs
+	dh_installdeb
+	dh_shlibdeps
+	dh_gencontrol
+	dh_md5sums
+	dh_builddeb -- -Z lzma
+
+binary: binary-indep binary-arch
+.PHONY: build clean binary-indep binary-arch binary install configure