Index: trunk/include/expat/expat.h
===================================================================
--- trunk/include/expat/expat.h	(revision 97)
+++ trunk/include/expat/expat.h	(revision 98)
@@ -13,12 +13,21 @@
                         // to save the app from having to include this as well
 
-#ifndef XMLPARSEAPI
+/* #ifndef XMLPARSEAPI
     #ifdef EXPATENTRY
-        #define XMLPARSEAPI(type) type EXPATENTRY
+        // #define XMLPARSEAPI(type) type EXPATENTRY
+        #define XMLPARSEAPI(type)
             // V0.9.14 (2001-08-09) [umoeller]
     #else
         #define XMLPARSEAPI(type) type
     #endif
-#endif
+#endif */
+
+#ifndef XMLPARSEAPI
+#  ifdef __declspec
+#    define XMLPARSEAPI __declspec(dllimport)
+#  else
+#    define XMLPARSEAPI /* nothing */
+#  endif
+#endif  /* not defined XMLPARSEAPI */
 
 #ifdef __cplusplus
@@ -119,11 +128,10 @@
 */
 
-typedef void (*XML_ElementDeclHandler) (void *userData,
+typedef void (* EXPATENTRY XML_ElementDeclHandler) (void *userData,
                                         const XML_Char *name,
                                         XMLCONTENT *model);
 
-XMLPARSEAPI(void)
-XML_SetElementDeclHandler(XML_Parser parser,
-              XML_ElementDeclHandler eldecl);
+void EXPATENTRY XML_SetElementDeclHandler(XML_Parser parser,
+                                            XML_ElementDeclHandler eldecl);
 
 /*
@@ -137,5 +145,5 @@
  */
 
-typedef void (*XML_AttlistDeclHandler) (void           *userData,
+typedef void (* EXPATENTRY XML_AttlistDeclHandler) (void           *userData,
                                         const XML_Char *elname,
                                         const XML_Char *attname,
@@ -144,5 +152,5 @@
                                         int     isrequired);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetAttlistDeclHandler(XML_Parser parser,
               XML_AttlistDeclHandler attdecl);
@@ -157,10 +165,10 @@
   */
 
-typedef void (*XML_XmlDeclHandler) (void        *userData,
+typedef void (* EXPATENTRY XML_XmlDeclHandler) (void        *userData,
                                     const XML_Char  *version,
                                     const XML_Char  *encoding,
                                     int          standalone);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetXmlDeclHandler(XML_Parser parser,
               XML_XmlDeclHandler xmldecl);
@@ -176,5 +184,5 @@
 external protocol or null if there is none specified. */
 
-XMLPARSEAPI(XML_Parser)
+XML_Parser EXPATENTRY
 XML_ParserCreate(const XML_Char *encoding);
 
@@ -189,5 +197,5 @@
 the name and prefix will be passed through without expansion. */
 
-XMLPARSEAPI(XML_Parser)
+XML_Parser EXPATENTRY
 XML_ParserCreateNS(const XML_Char *encoding, XML_Char namespaceSeparator);
 
@@ -203,5 +211,5 @@
 */
 
-XMLPARSEAPI(XML_Parser)
+XML_Parser EXPATENTRY
 XML_ParserCreate_MM(const XML_Char *encoding,
             const XML_Memory_Handling_Suite *memsuite,
@@ -211,27 +219,27 @@
    names and values are 0 terminated. */
 
-typedef void (*XML_StartElementHandler)(void *userData,
+typedef void (* EXPATENTRY XML_StartElementHandler)(void *userData,
                                         const XML_Char *name,
                                         const XML_Char **atts);
 
-typedef void (*XML_EndElementHandler)(void *userData,
+typedef void (* EXPATENTRY XML_EndElementHandler)(void *userData,
                                       const XML_Char *name);
 
 
 /* s is not 0 terminated. */
-typedef void (*XML_CharacterDataHandler)(void *userData,
+typedef void (* EXPATENTRY XML_CharacterDataHandler)(void *userData,
                                          const XML_Char *s,
                                          int len);
 
 /* target and data are 0 terminated */
-typedef void (*XML_ProcessingInstructionHandler)(void *userData,
+typedef void (* EXPATENTRY XML_ProcessingInstructionHandler)(void *userData,
                                                  const XML_Char *target,
                                                  const XML_Char *data);
 
 /* data is 0 terminated */
-typedef void (*XML_CommentHandler)(void *userData, const XML_Char *data);
-
-typedef void (*XML_StartCdataSectionHandler)(void *userData);
-typedef void (*XML_EndCdataSectionHandler)(void *userData);
+typedef void (* EXPATENTRY XML_CommentHandler)(void *userData, const XML_Char *data);
+
+typedef void (* EXPATENTRY XML_StartCdataSectionHandler)(void *userData);
+typedef void (* EXPATENTRY XML_EndCdataSectionHandler)(void *userData);
 
 /* This is called for any characters in the XML document for
@@ -248,5 +256,5 @@
 multiple calls. */
 
-typedef void (*XML_DefaultHandler)(void *userData,
+typedef void (* EXPATENTRY XML_DefaultHandler)(void *userData,
                                    const XML_Char *s,
                                    int len);
@@ -255,5 +263,5 @@
    any DTD or internal subset is parsed. */
 
-typedef void (*XML_StartDoctypeDeclHandler)(void *userData,
+typedef void (* EXPATENTRY XML_StartDoctypeDeclHandler)(void *userData,
                                             const XML_Char *doctypeName,
                                             const XML_Char *sysid,
@@ -263,5 +271,5 @@
 /* This is called for the start of the DOCTYPE declaration when the
 closing > is encountered, but after processing any external subset. */
-typedef void (*XML_EndDoctypeDeclHandler)(void *userData);
+typedef void (* EXPATENTRY XML_EndDoctypeDeclHandler)(void *userData);
 
 /* This is called for entity declarations. The is_parameter_entity
@@ -281,5 +289,5 @@
 */
 
-typedef void (*XML_EntityDeclHandler) (void *userData,
+typedef void (* EXPATENTRY XML_EntityDeclHandler) (void *userData,
                                        const XML_Char *entityName,
                                        int is_parameter_entity,
@@ -291,5 +299,5 @@
                                        const XML_Char *notationName);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetEntityDeclHandler(XML_Parser parser,
              XML_EntityDeclHandler handler);
@@ -303,5 +311,5 @@
 The other arguments may be. */
 
-typedef void (*XML_UnparsedEntityDeclHandler)(void *userData,
+typedef void (* EXPATENTRY XML_UnparsedEntityDeclHandler)(void *userData,
                                               const XML_Char *entityName,
                                               const XML_Char *base,
@@ -314,5 +322,5 @@
 The notationName will never be null.  The other arguments can be. */
 
-typedef void (*XML_NotationDeclHandler)(void *userData,
+typedef void (* EXPATENTRY XML_NotationDeclHandler)(void *userData,
                                         const XML_Char *notationName,
                                         const XML_Char *base,
@@ -326,9 +334,9 @@
 For an xmlns="" attribute, uri will be null. */
 
-typedef void (*XML_StartNamespaceDeclHandler)(void *userData,
+typedef void (* EXPATENTRY XML_StartNamespaceDeclHandler)(void *userData,
                                               const XML_Char *prefix,
                                               const XML_Char *uri);
 
-typedef void (*XML_EndNamespaceDeclHandler)(void *userData,
+typedef void (* EXPATENTRY XML_EndNamespaceDeclHandler)(void *userData,
                                             const XML_Char *prefix);
 
@@ -339,5 +347,5 @@
 ERROR_EXPAT_NOT_STANDALONE error. */
 
-typedef int (*XML_NotStandaloneHandler)(void *userData);
+typedef int (* EXPATENTRY XML_NotStandaloneHandler)(void *userData);
 
 /* This is called for a reference to an external parsed general entity.
@@ -366,5 +374,5 @@
 userData. */
 
-typedef int (*XML_ExternalEntityRefHandler)(void *userData,     // added V0.9.14 (2001-08-09) [umoeller]
+typedef int (* EXPATENTRY XML_ExternalEntityRefHandler)(void *userData,     // added V0.9.14 (2001-08-09) [umoeller]
                                             XML_Parser parser,
                                             const XML_Char *context,
@@ -418,6 +426,6 @@
   int map[256];
   void *data;
-  int (*convert)(void *data, const char *s);
-  void (*release)(void *data);
+  int (* EXPATENTRY convert)(void *data, const char *s);
+  void (* EXPATENTRY release)(void *data);
 } XML_Encoding;
 
@@ -433,40 +441,40 @@
 then the parser will return an XML_UNKNOWN_ENCODING error. */
 
-typedef int (*XML_UnknownEncodingHandler)(void *encodingHandlerData,
+typedef int (* EXPATENTRY XML_UnknownEncodingHandler)(void *encodingHandlerData,
                                           const XML_Char *name,
                                           XML_Encoding *info);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetElementHandler(XML_Parser parser,
               XML_StartElementHandler start,
               XML_EndElementHandler end);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetStartElementHandler(XML_Parser, XML_StartElementHandler);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetEndElementHandler(XML_Parser, XML_EndElementHandler);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetCharacterDataHandler(XML_Parser parser,
                 XML_CharacterDataHandler handler);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetProcessingInstructionHandler(XML_Parser parser,
                     XML_ProcessingInstructionHandler handler);
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetCommentHandler(XML_Parser parser,
                       XML_CommentHandler handler);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetCdataSectionHandler(XML_Parser parser,
                XML_StartCdataSectionHandler start,
                XML_EndCdataSectionHandler end);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetStartCdataSectionHandler(XML_Parser parser,
                                 XML_StartCdataSectionHandler start);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetEndCdataSectionHandler(XML_Parser parser,
                               XML_EndCdataSectionHandler end);
@@ -476,5 +484,5 @@
 handler. */
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetDefaultHandler(XML_Parser parser,
               XML_DefaultHandler handler);
@@ -484,47 +492,47 @@
 default handler. */
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetDefaultHandlerExpand(XML_Parser parser,
                     XML_DefaultHandler handler);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetDoctypeDeclHandler(XML_Parser parser,
               XML_StartDoctypeDeclHandler start,
               XML_EndDoctypeDeclHandler end);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetStartDoctypeDeclHandler(XML_Parser parser,
                    XML_StartDoctypeDeclHandler start);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetEndDoctypeDeclHandler(XML_Parser parser,
                  XML_EndDoctypeDeclHandler end);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetUnparsedEntityDeclHandler(XML_Parser parser,
                  XML_UnparsedEntityDeclHandler handler);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetNotationDeclHandler(XML_Parser parser,
                XML_NotationDeclHandler handler);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetNamespaceDeclHandler(XML_Parser parser,
                 XML_StartNamespaceDeclHandler start,
                 XML_EndNamespaceDeclHandler end);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetStartNamespaceDeclHandler(XML_Parser parser,
                  XML_StartNamespaceDeclHandler start);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetEndNamespaceDeclHandler(XML_Parser parser,
                    XML_EndNamespaceDeclHandler end);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetNotStandaloneHandler(XML_Parser parser,
                 XML_NotStandaloneHandler handler);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetExternalEntityRefHandler(XML_Parser parser,
                 XML_ExternalEntityRefHandler handler);
@@ -533,8 +541,8 @@
 as the first argument to the external entity ref handler instead
 of the parser object. */
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetExternalEntityRefHandlerArg(XML_Parser, void *arg);
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetUnknownEncodingHandler(XML_Parser parser,
                   XML_UnknownEncodingHandler handler,
@@ -544,5 +552,5 @@
 processing instruction or character data.  It causes the corresponding
 markup to be passed to the default handler. */
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_DefaultCurrent(XML_Parser parser);
 
@@ -558,9 +566,9 @@
 */
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetReturnNSTriplet(XML_Parser parser, int do_nst);
 
 /* This value is passed as the userData argument to callbacks. */
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_SetUserData(XML_Parser parser, void *userData);
 
@@ -572,5 +580,5 @@
 or XML_ParseBuffer. */
 
-XMLPARSEAPI(int)
+int EXPATENTRY
 XML_SetEncoding(XML_Parser parser, const XML_Char *encoding);
 
@@ -579,5 +587,5 @@
 The userData will still be accessible using XML_GetUserData. */
 
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_UseParserAsHandlerArg(XML_Parser parser);
 
@@ -589,8 +597,8 @@
 Returns zero if out of memory, non-zero otherwise. */
 
-XMLPARSEAPI(int)
+int EXPATENTRY
 XML_SetBase(XML_Parser parser, const XML_Char *base);
 
-XMLPARSEAPI(const XML_Char *)
+const XML_Char * EXPATENTRY
 XML_GetBase(XML_Parser parser);
 
@@ -601,5 +609,5 @@
 XML_StartElementHandler. */
 
-XMLPARSEAPI(int)
+int EXPATENTRY
 XML_GetSpecifiedAttributeCount(XML_Parser parser);
 
@@ -609,5 +617,5 @@
 into the atts array passed to the XML_StartElementHandler. */
 
-XMLPARSEAPI(int)
+int EXPATENTRY
 XML_GetIdAttributeIndex(XML_Parser parser);
 
@@ -615,11 +623,11 @@
 The last call to XML_Parse must have isFinal true;
 len may be zero for this call (or any other). */
-XMLPARSEAPI(int)
+int EXPATENTRY
 XML_Parse(XML_Parser parser, const char *s, int len, int isFinal);
 
-XMLPARSEAPI(void *)
+void * EXPATENTRY
 XML_GetBuffer(XML_Parser parser, int len);
 
-XMLPARSEAPI(int)
+int EXPATENTRY
 XML_ParseBuffer(XML_Parser parser, int len, int isFinal);
 
@@ -639,5 +647,5 @@
 from the parser argument.  Returns 0 if out of memory.  Otherwise
 returns a new XML_Parser object. */
-XMLPARSEAPI(XML_Parser)
+XML_Parser EXPATENTRY
 XML_ExternalEntityParserCreate(XML_Parser parser,
                    const XML_Char *context,
@@ -669,5 +677,5 @@
 entities is requested; otherwise it will return non-zero. */
 
-XMLPARSEAPI(int)
+int EXPATENTRY
 XML_SetParamEntityParsing(XML_Parser parser,
               enum XML_ParamEntityParsing parsing);
@@ -732,5 +740,5 @@
 returns information about the error. */
 
-XMLPARSEAPI(XMLERROR)
+XMLERROR EXPATENTRY
 XML_GetErrorCode(XML_Parser parser);
 
@@ -743,12 +751,12 @@
 of the sequence of characters that generated the event. */
 
-XMLPARSEAPI(int) XML_GetCurrentLineNumber(XML_Parser parser);
-XMLPARSEAPI(int) XML_GetCurrentColumnNumber(XML_Parser parser);
-XMLPARSEAPI(long) XML_GetCurrentByteIndex(XML_Parser parser);
+int EXPATENTRY XML_GetCurrentLineNumber(XML_Parser parser);
+int EXPATENTRY XML_GetCurrentColumnNumber(XML_Parser parser);
+long EXPATENTRY XML_GetCurrentByteIndex(XML_Parser parser);
 
 /* Return the number of bytes in the current event.
 Returns 0 if the event is in an internal entity. */
 
-XMLPARSEAPI(int)
+int EXPATENTRY
 XML_GetCurrentByteCount(XML_Parser parser);
 
@@ -763,5 +771,5 @@
    the handler that makes the call. */
 
-XMLPARSEAPI(const char *)
+const char * EXPATENTRY
 XML_GetInputContext(XML_Parser parser,
             int *offset,
@@ -774,13 +782,13 @@
 
 /* Frees memory used by the parser. */
-XMLPARSEAPI(void)
+void EXPATENTRY
 XML_ParserFree(XML_Parser parser);
 
 /* Returns a string describing the error. */
-XMLPARSEAPI(const XML_LChar *)
+const XML_LChar * EXPATENTRY
 XML_ErrorString(int code);
 
 /* Return a string containing the version number of this expat */
-XMLPARSEAPI(const XML_LChar *)
+const XML_LChar * EXPATENTRY
 XML_ExpatVersion(void);
 
@@ -794,5 +802,5 @@
    number information for this version of expat */
 
-XMLPARSEAPI(XML_Expat_Version)
+XML_Expat_Version EXPATENTRY
 XML_ExpatVersionInfo(void);
 
Index: trunk/include/expat/xmlrole.h
===================================================================
--- trunk/include/expat/xmlrole.h	(revision 97)
+++ trunk/include/expat/xmlrole.h	(revision 98)
@@ -6,4 +6,8 @@
 #ifndef XmlRole_INCLUDED
 #define XmlRole_INCLUDED 1
+
+#include "expat\expat_setup.h"
+                        // V0.9.9 (2001-02-10) [umoeller]
+                        // to save the app from having to include this as well
 
 #include "expat\xmltok.h"
@@ -73,10 +77,13 @@
 };
 
+struct prolog_state;
+typedef int EXPATENTRY FNHANDLER(struct prolog_state *state,
+                      int tok,
+                      const char *ptr,
+                      const char *end,
+                      const ENCODING *enc);
+
 typedef struct prolog_state {
-  int (*handler)(struct prolog_state *state,
-             int tok,
-         const char *ptr,
-         const char *end,
-         const ENCODING *enc);
+  FNHANDLER *handler;
   unsigned level;
 #ifdef XML_DTD
Index: trunk/include/expat/xmltok.h
===================================================================
--- trunk/include/expat/xmltok.h	(revision 97)
+++ trunk/include/expat/xmltok.h	(revision 98)
@@ -6,4 +6,8 @@
 #ifndef XmlTok_INCLUDED
 #define XmlTok_INCLUDED 1
+
+#include "expat\expat_setup.h"
+                        // V0.9.9 (2001-02-10) [umoeller]
+                        // to save the app from having to include this as well
 
 #ifdef __cplusplus
@@ -17,5 +21,5 @@
 #define XML_TOK_NONE -4    /* The string to be scanned is empty */
 #define XML_TOK_TRAILING_CR -3 /* A CR at the end of the scan;
-                                  might be part of CRLF sequence */ 
+                                  might be part of CRLF sequence */
 #define XML_TOK_PARTIAL_CHAR -2 /* only part of a multibyte sequence */
 #define XML_TOK_PARTIAL -1 /* only part of a token */
@@ -122,39 +126,43 @@
 typedef struct encoding ENCODING;
 
+typedef int EXPATENTRY SCANNERFUNC(const ENCODING *,
+                                   const char *,
+                                   const char *,
+                                   const char **);
+typedef SCANNERFUNC *PSCANNERFUNC;
+
 struct encoding {
-  int (*scanners[XML_N_STATES])(const ENCODING *,
-			        const char *,
-			        const char *,
-			        const char **);
-  int (*literalScanners[XML_N_LITERAL_TYPES])(const ENCODING *,
-					      const char *,
-					      const char *,
-					      const char **);
-  int (*sameName)(const ENCODING *,
-	          const char *, const char *);
-  int (*nameMatchesAscii)(const ENCODING *,
-			  const char *, const char *, const char *);
-  int (*nameLength)(const ENCODING *, const char *);
-  const char *(*skipS)(const ENCODING *, const char *);
-  int (*getAtts)(const ENCODING *enc, const char *ptr,
-	         int attsMax, ATTRIBUTE *atts);
-  int (*charRefNumber)(const ENCODING *enc, const char *ptr);
-  int (*predefinedEntityName)(const ENCODING *, const char *, const char *);
-  void (*updatePosition)(const ENCODING *,
-			 const char *ptr,
-			 const char *end,
-			 POSITION *);
-  int (*isPublicId)(const ENCODING *enc, const char *ptr, const char *end,
-		    const char **badPtr);
-  void (*utf8Convert)(const ENCODING *enc,
-		      const char **fromP,
-		      const char *fromLim,
-		      char **toP,
-		      const char *toLim);
-  void (*utf16Convert)(const ENCODING *enc,
-		       const char **fromP,
-		       const char *fromLim,
-		       unsigned short **toP,
-		       const unsigned short *toLim);
+  PSCANNERFUNC scanners[XML_N_STATES];
+  PSCANNERFUNC      literalScanners[XML_N_LITERAL_TYPES];
+  /* int (* EXPATENTRY literalScanners[XML_N_LITERAL_TYPES])(const ENCODING *,
+                          const char *,
+                          const char *,
+                          const char **); */
+  int (* EXPATENTRY sameName)(const ENCODING *,
+              const char *, const char *);
+  int (* EXPATENTRY nameMatchesAscii)(const ENCODING *,
+              const char *, const char *, const char *);
+  int (* EXPATENTRY nameLength)(const ENCODING *, const char *);
+  const char *(* EXPATENTRY skipS)(const ENCODING *, const char *);
+  int (* EXPATENTRY getAtts)(const ENCODING *enc, const char *ptr,
+             int attsMax, ATTRIBUTE *atts);
+  int (* EXPATENTRY charRefNumber)(const ENCODING *enc, const char *ptr);
+  int (* EXPATENTRY predefinedEntityName)(const ENCODING *, const char *, const char *);
+  void (* EXPATENTRY updatePosition)(const ENCODING *,
+             const char *ptr,
+             const char *end,
+             POSITION *);
+  int (* EXPATENTRY isPublicId)(const ENCODING *enc, const char *ptr, const char *end,
+            const char **badPtr);
+  void (* EXPATENTRY utf8Convert)(const ENCODING *enc,
+              const char **fromP,
+              const char *fromLim,
+              char **toP,
+              const char *toLim);
+  void (* EXPATENTRY utf16Convert)(const ENCODING *enc,
+               const char **fromP,
+               const char *fromLim,
+               unsigned short **toP,
+               const unsigned short *toLim);
   int minBytesPerChar;
   char isUtf8;
@@ -203,5 +211,5 @@
 
 /* This is used for performing a 2nd-level tokenization on
-the content of a literal that has already been returned by XmlTok. */ 
+the content of a literal that has already been returned by XmlTok. */
 
 #define XmlLiteralTok(enc, literalType, ptr, end, nextTokPtr) \
@@ -252,13 +260,13 @@
 
 int  XmlParseXmlDecl(int isGeneralTextEntity,
-			      const ENCODING *enc,
-			      const char *ptr,
-	  		      const char *end,
-			      const char **badPtr,
-			      const char **versionPtr,
-			      const char **versionEndPtr,
-			      const char **encodingNamePtr,
-			      const ENCODING **namedEncodingPtr,
-			      int *standalonePtr);
+                  const ENCODING *enc,
+                  const char *ptr,
+                  const char *end,
+                  const char **badPtr,
+                  const char **versionPtr,
+                  const char **versionEndPtr,
+                  const char **encodingNamePtr,
+                  const ENCODING **namedEncodingPtr,
+                  int *standalonePtr);
 
 int  XmlInitEncoding(INIT_ENCODING *, const ENCODING **, const char *name);
@@ -271,18 +279,18 @@
 ENCODING  *
 XmlInitUnknownEncoding(void *mem,
-		       int *table,
-		       int (*conv)(void *userData, const char *p),
-		       void *userData);
+               int *table,
+               int (*conv)(void *userData, const char *p),
+               void *userData);
 
 int  XmlParseXmlDeclNS(int isGeneralTextEntity,
-			        const ENCODING *enc,
-			        const char *ptr,
-	  		        const char *end,
-			        const char **badPtr,
-			        const char **versionPtr,
-				const char **versionEndPtr,
-			        const char **encodingNamePtr,
-			        const ENCODING **namedEncodingPtr,
-			        int *standalonePtr);
+                    const ENCODING *enc,
+                    const char *ptr,
+                    const char *end,
+                    const char **badPtr,
+                    const char **versionPtr,
+                const char **versionEndPtr,
+                    const char **encodingNamePtr,
+                    const ENCODING **namedEncodingPtr,
+                    int *standalonePtr);
 int  XmlInitEncodingNS(INIT_ENCODING *, const ENCODING **, const char *name);
 const ENCODING  *XmlGetUtf8InternalEncodingNS(void);
@@ -290,7 +298,7 @@
 ENCODING  *
 XmlInitUnknownEncodingNS(void *mem,
-		         int *table,
-		         int (*conv)(void *userData, const char *p),
-		         void *userData);
+                 int *table,
+                 int (*conv)(void *userData, const char *p),
+                 void *userData);
 #ifdef __cplusplus
 }
Index: trunk/include/helpers/xml.h
===================================================================
--- trunk/include/helpers/xml.h	(revision 97)
+++ trunk/include/helpers/xml.h	(revision 98)
@@ -630,5 +630,5 @@
 
     typedef APIRET APIENTRY FNEXTERNALHANDLER(PXMLDOM pDom,
-                                              XML_Parser *pSubParser,
+                                              XML_Parser pSubParser,
                                               const char *pcszSystemID,
                                               const char *pcszPublicID);