Index: /trunk/mkspecs/os2-g++/emxexpw.cmd
===================================================================
--- /trunk/mkspecs/os2-g++/emxexpw.cmd	(revision 101)
+++ /trunk/mkspecs/os2-g++/emxexpw.cmd	(revision 102)
@@ -92,6 +92,6 @@
 
 /* check options */
-if (Opt.!DefFile == '') then call Error E_NoDefFile
-if (Opt.!Objects.0 == 0) then call Error E_NoObjectFiles
+if (Opt.!DefFile == '') then call Error "E_NoDefFile"
+if (Opt.!Objects.0 == 0) then call Error "E_NoObjectFiles"
 
 /* apply default options */
@@ -102,5 +102,5 @@
 /* check emxexp.exe existence */
 G.emxexp_exe = SysSearchPath('PATH', 'EMXEXP.EXE')
-if (G.emxexp_exe == '') then call Error E_CantFindEMXEXP
+if (G.emxexp_exe == '') then call Error "E_CantFindEMXEXP"
 
 Opt.!ObjectsList = ''
@@ -133,5 +133,5 @@
     rc = SysFileDelete(Opt.!DefFile)
     if (rc \== 0 & rc \== 2) then
-        call Error E_CantDeleteFile, Opt.!DefFile, rc
+        call Error "E_CantDeleteFile", Opt.!DefFile, rc
 
     /* write object files to a responce file for EMXEXP */
@@ -186,5 +186,5 @@
 
             if (rc \== 0) then
-                call Error E_EMXEXPFailed, rc
+                call Error "E_EMXEXPFailed", rc
         end
 
@@ -212,5 +212,5 @@
         else
             G.emxexp_exe Opt.!ObjectsList '>'G.!TempDefFile
-        if (rc \== 0) then call Error E_EMXEXPFailed, rc
+        if (rc \== 0) then call Error "E_EMXEXPFailed", rc
 
         if (G.!ObjectListFile \= '') then do
@@ -224,5 +224,5 @@
 
         if (G.!Exports.0 == 0) then
-            call Error E_NoExports
+            call Error "E_NoExports"
 
         /* update the map file */
@@ -230,5 +230,5 @@
         rc = SysFileDelete(Opt.!DefMap)
         if (rc \== 0 & rc \== 2) then
-            call Error E_CantDeleteFile, Opt.!DefMap, rc
+            call Error "E_CantDeleteFile", Opt.!DefMap, rc
 
         stats = AppendExportsToFile(Opt.!DefMap)
@@ -307,5 +307,5 @@
         parse value stream(Opt.!DefTemplate, 'C', 'OPEN READ') with status':'code
         if (status \== 'READY') then
-            call Error E_CantOpenFile, Opt.!DefTemplate, code
+            call Error "E_CantOpenFile", Opt.!DefTemplate, code
         do while lines(Opt.!DefTemplate)
             str = linein(Opt.!DefTemplate)
@@ -424,8 +424,8 @@
                 parse value(G.!line.w) with '@'ordinal
             if (\datatype(ordinal, 'W') | ordinal <= 0) then
-                call Error E_InvalidOrdinal, symbol, ordinal, file, ln
+                call Error "E_InvalidOrdinal", symbol, ordinal, file, ln
             w = w + 1
             if (G.!line.0 < w | translate(G.!line.w) \== 'NONAME') then
-                call Error E_NoNoname, symbol, file, ln
+                call Error "E_NoNoname", symbol, file, ln
             w = w + 1
         end
@@ -457,5 +457,5 @@
             when (magicseg == 'TEXT32') then nop
             otherwise
-                call Error E_InvalidMagicSeg, symbol, magicseg, file, ln
+                call Error "E_InvalidMagicSeg", symbol, magicseg, file, ln
         end
 
@@ -475,5 +475,5 @@
             signal on novalue
             if (datatype(o, 'W')) then
-                call Error E_DuplicateSymbol, symbol, file, ln
+                call Error "E_DuplicateSymbol", symbol, file, ln
             G.!Exports.symbol = n /* back reference! */
             if (G.!Exports.!maxOrd < ordinal) then
@@ -596,5 +596,5 @@
             o = substr(G.!opts.i, 2)
             if (stream(o, 'C', 'QUERY EXISTS') == '') then
-                call Error E_FileNotFound, o
+                call Error "E_FileNotFound", o
             resp_options = resp_options || charin(o,, chars(o))
         end
@@ -640,5 +640,5 @@
                 end
                 otherwise
-                    call Error E_InvalidOption, o
+                    call Error "E_InvalidOption", o
             end
         end
@@ -858,21 +858,21 @@
     eol = '0D0A'x
 
-    e.E_CantFindEMXEXP  = 'Cannot find EMXEXP.EXE in the PATH.'
-    e.E_CantOpenFile    = 'Cannot open file ''%1'' (RC = %2).'
-    e.E_CantDeleteFile  = 'Cannot delete file ''%1'' (RC = %2).'
-    e.E_InvalidOption   = 'Invalid option: ''%1''.'
-    e.E_FileNotFound    = 'File not found: ''%1''.'
-    e.E_NoDefFile       = 'No output DEF file.'
-    e.E_NoObjectFiles   = 'No input object files.'
-    e.E_EMXEXPFailed    = 'EMXEXP.EXE failed with RC = %1.'
-    e.E_NoExports   =,
+    e.E_CantFindEMXEXP   = 'Cannot find EMXEXP.EXE in the PATH.'
+    e.E_CantOpenFile     = 'Cannot open file ''%1'' (RC = %2).'
+    e.E_CantDeleteFile   = 'Cannot delete file ''%1'' (RC = %2).'
+    e.E_InvalidOption    = 'Invalid option: ''%1''.'
+    e.E_FileNotFound     = 'File not found: ''%1''.'
+    e.E_NoDefFile        = 'No output DEF file.'
+    e.E_NoObjectFiles    = 'No input object files.'
+    e.E_EMXEXPFailed     = 'EMXEXP.EXE failed with RC = %1.'
+    e.E_NoExports        =,
         'The specified list of objects doesn''t export any symbols.'
-    e.E_InvalidMagicSeg =,
+    e.E_InvalidMagicSeg  =,
         'Invalid or missing magic segment ''%2'' for symbol "%1" in ''%3'' (line %4).'
-    e.E_InvalidOrdinal  =,
+    e.E_InvalidOrdinal   =,
         'Invalid or missing ordinal ''%2'' for symbol "%1" in ''%3'' (line %4).'
-    e.E_NoNoname        =,
+    e.E_NoNoname         =,
         'No NONAME keyword for symbol "%1" in ''%2'' (line %3).'
-    e.E_DuplicateSymbol =,
+    e.E_DuplicateSymbol  =,
         'Duplicate symbol symbol "%1" detected in ''%2'' (line %3).'
 