Index: trunk/classes/help/en/cwmm.ipf
===================================================================
--- trunk/classes/help/en/cwmm.ipf	(revision 101)
+++ trunk/classes/help/en/cwmm.ipf	(revision 103)
@@ -1,164 +1,306 @@
 :userdoc.
-
 :docprof.
-
-:title.Help
-
+:title.CWMM Help
+
+.* ----------------------------------------------------------------------------
 :h1 res=010.MP3 audio file
-:p.
-This file is an MP3 audio file. It may be played using MMOS/2
-after installing of MMIOMP3 a free multimedia IO procedure.
-MP3 files contain compressed audio data.
-The compression is not lossless.
-:p.
-Get the IO procedure from
-:p.
-
-https&colon.//hobbes.nmsu.edu/download/pub/os2/apps/mmedia/codec/MMeCS-MP3_1-2.zip
-
-:h1 res=011.ID3 Tag
-:p.
-Use this page for the editing of ID3 tags.
-If the entry fields
-are empty this file does not have any tag yet.
-The new information is only saved after pressing the :hp2.Save:ehp2.
-button.
-
-:p.
-The following information may be specified:
-:ul.
-:li.:hp2.Name:ehp2.
-.br
-The name of the track. The length is restricted to 30 characters.
-
-:li.:hp2.Artist:ehp2.
-.br
-The name of the Artist. The length is restricted to 30 characters.
-
-:li.:hp2.Album:ehp2.
-.br
-The album containing this track. The length is restricted to 30 characters.
-
-:li.:hp2.Comment:ehp2.
-.br
-An arbitrary comment. The length is restricted to 30 characters.
-
-:li.:hp2.Year:ehp2.
-.br
-The year the album was published.
-
-:li.:hp2.Genre:ehp2.
-.br
-The Genre of this track.
-
-:eul.
-
-:h1 res=013.ID3 Tag
-:p.
-This page displays the ID3 tags of the MP3 file. ID3 is a standard to add information
-to an MP3 file like the title of the track or the tracks artist.
-:p.
-If the entry fields are empty this file does not have any tag yet.
-
-:p.
-:ul.
-:li.:hp2.Name:ehp2.
-.br
-The name of the track. The length is restricted to 30 characters.
-
-:li.:hp2.Artist:ehp2.
-.br
-The name of the Artist. The length is restricted to 30 characters.
-
-:li.:hp2.Album:ehp2.
-.br
-The album containing this track. The length is restricted to 30 characters.
-
-:li.:hp2.Comment:ehp2.
-.br
-An arbitrary comment. The length is restricted to 30 characters.
-
-:li.:hp2.Year:ehp2.
-.br
-The year the album was published.
-
-:li.:hp2.Genre:ehp2.
-.br
-The Genre of this track.
-
-:eul.
-
+:p.This file is an MP3 audio file. It may be played using MMOS/2 when a suitable
+MP3 MMIOProc has been installed.
+
+:p.The MP3 format uses lossy compression to reduce the file size of the source
+material. The amount of loss may or may not be acceptable. Usually, the amount
+may be controlled by the encoding tool. Once encoded, however, it is not
+possible to restore the bits which have been discarded. The source file must be
+re-encoded again with a lower degree of loss.
+
+:p.An MP3 MMIOProc package is included in the MMAudio Pak 2, available from&colon.
+
+:p.http&colon.//r6.ca/MMAudioPak/
+
+.* ----------------------------------------------------------------------------
+:h1 res=011.ID3 tag
+:p.Use this page to edit selected ID3 tag fields.
+
+:p.An ID3 tag is metadata associated with a particular track, and is stored in
+the MP3 file. ID3 is a :hp1.de facto:ehp1. standard, generally recognized by
+most MP3 players.
+
+:p.If all entry fields are empty, the file does not have an ID3 tag. If some
+fields are empty, this data has not been added to the tag.
+
+:p.The new information is only saved after pressing the :hp2.Save:ehp2. button.
+
+:p.The following information may be specified:
+
+:hp2.
+:table rules=both frame=box cols='10 8 40'.
+:row.
+:c.Field
+:c.Length
+:c.Description
+:row.
+:c.Name
+:c.30
+:c.The name of the track.
+:row.
+:c.Artist
+:c.30
+:c.The name of the artist.
+:row.
+:c.Album
+:c.30
+:c.The album containing the track.
+:row.
+:c.Comment
+:c.30
+:c.An arbitrary comment about the track.
+:row.
+:c.Year
+:c.4
+:c.The 4-digit year in which the album was published.
+:row.
+:c.Genre
+:c.30
+:c.The genre of this track; select from dropdown.
+:etable.
+:ehp2.
+
+.* ----------------------------------------------------------------------------
+:h1 res=013.ID3 tag
+:p.This page displays selected fields of the ID3 tag attached to the MP3 file.
+
+:p.An ID3 tag is metadata associated with a particular track, and is stored in
+the MP3 file. ID3 is a :hp1.de facto:ehp1. standard, generally recognized by
+most MP3 players.
+
+:p.If all entry fields are empty, the file does not have an ID3 tag. If some
+fields are empty, this data has not been added to the tag.
+
+:p.The new information is only saved after pressing the :hp2.Save:ehp2. button.
+
+:p.The following information may be specified:
+
+:hp2.
+:table rules=both frame=box cols='10 8 40'.
+:row.
+:c.Field
+:c.Length
+:c.Description
+:row.
+:c.Name
+:c.30
+:c.The name of the track.
+:row.
+:c.Artist
+:c.30
+:c.The name of the artist.
+:row.
+:c.Album
+:c.30
+:c.The album containing the track.
+:row.
+:c.Comment
+:c.30
+:c.An arbitrary comment about the track.
+:row.
+:c.Year
+:c.4
+:c.The 4-digit year in which the album was published.
+:row.
+:c.Genre
+:c.30
+:c.The genre of this track; select from dropdown.
+:etable.
+:ehp2.
+
+.* ----------------------------------------------------------------------------
 :h1 res=012.Track meta data
-:p.
-Use this page for the editing of track information. The contents of the fields will be saved
-in the extended attributes of the file.
-The new information will be only saved after pressing the :hp2.Save:ehp2.
-button.
+:p.Use this page to edit track information. Unlike an ID3 tag, the contents of
+these fields will be saved in the extended attributes of the file upon pressing
+the :hp2.Save:ehp2. button.
+
 :nt.
-Extended attributes are only supported with OS/2 and they're not stored on CD. So
-if you copy the files to CD or another operating system they will be lost.
+Extended attributes are only supported by OS/2 and other operating systems which
+utilize these data structures in their filesystems (HPFS, JFS, XFS, ZFS, and to
+a limited extent, ext4). Further, this information is not written to CD or DVD.
+As a result, this data won't be saved or transferred along with its associated
+files to any system which does not recognize extended attributes, resulting in
+such copies lacking this data, even if it is present and intact in the source.
+Use this feature with care.
 :ent.
-:p.
-The following information may be specified. The length of each field is restricted to 256 characters. 
-:ul.
-:li.:hp2.Name&colon.:ehp2.
-:p.The name of the track.
-
-:li.:hp2.Artist&colon.:ehp2.
-:p.The name of the Artist.
-
-:li.:hp2.Album&colon.:ehp2.
-:p.The album containing this track.
-
-:li.:hp2.Comment&colon.:ehp2.
-:p.An arbitrary comment.
-
-:li.:hp2.Year&colon.:ehp2.
-:p.The year the album was published.
-
-:li.:hp2.Genre&colon.:ehp2.
-:p.The Genre of this track.
-
-:eul.
-
-:h1 res=020.Help for Ogg audio file
-:p.
-This file is an Ogg audio file. It may be played using MMOS/2
-after installing of MMIOVORB a free multimedia IO procedure.
-Ogg files contain comressed audio data similar to MP3 files.
-The compression is not lossless.
-:p.
-Get the IO procedure from
-:p.
-:link reftype=launch
-object='netscape.exe'
-data='http://www.math.berkeley.edu/~roconnor/'.
-http&colon.//www.math.berkeley.edu/~roconnor/:elink.
-
-
-:h1 res=030.Help for CD track
-:p.
-This object is a CD audio track. Track names and other info is
-queried from a FreeDB server if an internet connection is available.
-You have to specify your email address to use FreeDB. Use the configuration
-object to do so.
-:p.
-The user information is stored in the cddb.ini file in the installation directory.
-
-
-:h1 res=040.Help for M3U playlist
-:p.
-This object is a M3U playlist. An M3U playlist is a text file which contains
-paths to the tracks to be played. These playlists are used e.g. by portable
-MP3 players. An editor is available to modify M3U files using the mouse (drag and drop).
-
-:h1 res=050.Help for Audio stream
-:p.
-This object plays a stream from a streaming server on the internet.
-The URL for the server can be specified using the properties notebook.
+
+:p.The following information may be specified. The length of each field is
+limited to 256 characters
+
+:hp2.
+:table rules=both frame=box cols='10 40'.
+:row.
+:c.Field
+:c.Description
+:row.
+:c.Name
+:c.The name of the track.
+:row.
+:c.Artist
+:c.The name of the artist.
+:row.
+:c.Album
+:c.The album containing the track.
+:row.
+:c.Comment
+:c.An arbitrary comment about the track.
+:row.
+:c.Year
+:c.The 4-digit year in which the album was published.
+:row.
+:c.Genre
+:c.The genre of this track; select from dropdown.
+:etable.
+:ehp2.
+
+.* ----------------------------------------------------------------------------
+:h1 res=014.Audio details
+:p.This page displays various technical details about the selected audio track.
+
+:p.The following read-only information is provided&colon.
+
+:hp2.
+:table rules=both frame=box cols='20 40'.
+:row.
+:c.Detail
+:c.Description
+:row.
+:c.Play time
+:c.Recording length in mm&colon.ss.
+:row.
+:c.Sample rate
+:c.For digital audio, this refers to the number of samples taken per second.
+Generally, the higher the sample rate (sample frequency), the higher the quality
+of the resulting audio stream.
+:row.
+:c.Bits per sample
+:c.Bit depth of each sample. The greater the bit depth, the higher the quality of
+the resulting audio stream. CD quality audio utilizes a 16-bit depth.
+:row.
+:c.Channels
+:c.Number of audio channels in the file. Monaural audio contains a single
+channel, stereo contains two, etc.
+:etable.
+:ehp2.
+
+.* ----------------------------------------------------------------------------
+:h1 res=020.Ogg audio file
+:p.This file is an Ogg audio file. It may be played using MMOS/2 when a suitable
+Ogg MMIOProc has been installed. Ogg is actually a container format, and may
+consist of audio (Vorbis or Opus format for lossy compressed audio, or FLAC or
+OggPCM for lossless compressed audio) or video (Theora format, which is lossy).
+
+:p.The amount of loss in a Vorbis or Opus audio file may or may not be
+acceptable. Usually, the amount may be controlled by the encoding tool. Once
+encoded, however, it is not possible to restore the bits which have been
+discarded without re-encoding the source file again with a lower degree of loss.
+
+:p.Ogg MMIOProcs for FLAC and Vorbis are included with ArcaOS 5.x and above.
+Alternatively, these MMIOProcs are available in the MMAudio Pak 2 for OS/2&colon.
+
+:p.http&colon.//r6.ca/MMAudioPak/
+
+.* ----------------------------------------------------------------------------
+:h1 res=030.CD audio track
+:p.This file is a CD audio track. The track name and other info is queried from
+a CDDB server if an internet connection is available. The information presented
+here is read-only.
+
+:p.Most CDDB servers follow the FreeDB practice of requiring a valid email
+address for access. Use the FreeDB Client configuration object in the Multimedia
+folder to set this.
+
+:p.The user information is stored in the cddb.ini file in the installation
+directory.
+
+.* ----------------------------------------------------------------------------
+:h1 res=040.M3U playlist
+:p.This file is an M3U (Moving Picture Experts Group Audio Layer 3 Uniform
+Resource Locator) playlist. M3U is a :hp1.de facto:ehp1. standard, generally
+recognized by most music players.
+
+:p.An M3U playlist is a text file which contains paths (URLs) to the tracks it
+references.
+
+:p.To create a playlist, drag the M3U playlist template from the Multimedia
+Templates folder to a suitable location on the desktop. Drag and drop media
+files in the playlist container. To reorder, ensure that :hp1.Always maintain
+sort order:ehp1. option on the :hp2.Sort:ehp2. submenu is deselected, as well
+as any other sort options which might affect manual ordering, and drag and drop
+the tracks as desired. Save the playlist by selecting :hp2.File | Save:ehp2.
+from the menu.
+
+.* ----------------------------------------------------------------------------
+:h1 res=050.Audio stream
+:p.This object points to a stream provided by a streaming server on the LAN or
+across the internet. The URL for the server is specified in the properties
+notebook for the stream.
 
 :nt.
-Only Icecast server are supported. Servers using the shoutcast protocol won't work.
+Only Icecast servers are supported. Servers using other protocols (Ampache,
+SHOUTcast, QuickTime Broadcaster, Open Broadcast System, etc.) will not work.
 :ent.
 
+.* ----------------------------------------------------------------------------
+:h1 res=060.Convert audio file
+:p.Specify the target audio file type and filename, including the full path.
+Source audio file details are displayed at the top of the dialog. Note that some
+formats may be more lossy than others, and converting from a lossy format to a
+less-lossy (or lossless) format will not restore original bits which may no
+longer be present in the (lossy) source file, and in some cases, may result in
+a converted file of lower quality than the lossy source.
+
+:p.The dropdown will list available MMIOProcs (codecs) for the target file.
+
+:p.Press the :hp2.Convert:ehp2. button to begin the process, and
+:hp2.Abort:ehp2. to cancel once conversion has begun. Press :hp2.Close:ehp2. to
+exit the dialog.
+
+
+.* ----------------------------------------------------------------------------
+:h1 res=200.Image details
+:p.This page displays various technical details about the selected image.
+
+:p.The following read-only information is provided&colon.
+
+:hp2.
+:table rules=both frame=box cols='20 40'.
+:row.
+:c.Detail
+:c.Description
+:row.
+:c.IOProc
+:c.Identifies which MMIOProc is being used to render the image.
+:row.
+:c.Width
+:c.Width in pixels of the image.
+:row.
+:c.Height
+:c.Height in pixels of the image.
+:row.
+:c.Depth
+:c.Number of colors (color depth) of the image.
+:etable.
+:ehp2.
+
+.* ----------------------------------------------------------------------------
+:h1 res=210.Convert digital image
+:p.Specify the target image file type and filename, including the full path.
+A thumbnail of the source image file is displayed at the top of the dialog. Note
+that some formats may be more lossy than others, and converting from a lossy
+format to a less-lossy (or lossless) format will not restore original bits which
+may no longer be present in the (lossy) source file, and in some cases, may
+result in a converted file of lower quality than the lossy source.
+
+:p.The dropdown will list available MMIOProcs (codecs) for the target file.
+
+:p.Press the :hp2.Convert:ehp2. button to begin the process, and
+:hp2.Abort:ehp2. to cancel once conversion has begun. Press :hp2.Close:ehp2. to
+exit the dialog.
+
 :euserdoc.
Index: trunk/classes/res/en/cwaudio_en.rc
===================================================================
--- trunk/classes/res/en/cwaudio_en.rc	(revision 101)
+++ trunk/classes/res/en/cwaudio_en.rc	(revision 103)
@@ -31,5 +31,5 @@
 MENU ID_MENU_EDITOR
 BEGIN
-        MENUITEM "~Audioeditor", ID_MENU_EDITOR       
+        MENUITEM "~Audio editor", ID_MENU_EDITOR       
 END
 
@@ -77,5 +77,5 @@
 
 IDSTR_PLAYTIME      "Play time"
-IDSTR_SAMPLERATE    "Samplerate"
+IDSTR_SAMPLERATE    "Sample rate"
 IDSTR_CHANNELS      "Channels"
 IDSTR_BPS           "Bits per sample"
@@ -113,8 +113,8 @@
 ;Used as an information when starting and audio file from the WPS
 IDSTR_STARTINGTRACK      "Starting track..."
-IDSTR_AUDIOSCANNING     "Scanning Audiofile..."
-IDSTR_AUDIOSTREAMTITLE  "Audio-Stream"
-IDSTR_STREAMURLPAGENAME "~URL-Setting"
-IDSTR_CDTRACKTITLE      "CD-Track"
+IDSTR_AUDIOSCANNING     "Scanning audio file..."
+IDSTR_AUDIOSTREAMTITLE  "Audio stream"
+IDSTR_STREAMURLPAGENAME "~URL"
+IDSTR_CDTRACKTITLE      "CD track"
 IDSTR_M3UTITLE          "M3U playlist"
 ;Titles used when starting player and editor applications
@@ -127,4 +127,2 @@
 
 END
-
-